codeforces 869 E. The Untended Antiquity(树状数组)

题目链接:http://codeforces.com/contest/869/problem/E

 

题解:这题是挺好想到solution的但是不太好写,由于题目的特殊要求每个矩形不会重贴所以只要这两个点最内抱着他们的是同一个矩形就行了。就是最近抱汉她们的矩形是同一个就行了。有一种方法挺好的主要是数据是大多数随机的,所以可以考虑hash一下rand一下每个点的赋值然后求前缀和相同就是满足条件的,这里可以用一下2维德树状数组做一下。seed尽量大点这样失败的概率也就小点官方题解有详细的概率数据可以参考一下。然后就这样了........

#include <iostream>
#include <cstring>
#include <cstdio>
#include <map>
using namespace std;
const int M = 2500 + 10;
typedef unsigned long long ll;
pair<ll , ll> mmp[M][M];
pair<ll , ll> nub[M][M];
void add(int x , int y , pair<int , int> num) {
    for(int i = x ; i <= 2501 ; i += (i & (-i))) {
        for(int j = y ; j <= 2501 ; j += (j & (-j))) {
            nub[i][j].first += num.first;
            nub[i][j].second += num.second;
        }
    }
}
pair<ll , ll> query(int x , int y) {
    pair<ll , ll> res;
    for(int i = x ; i ; i -= (i & (-i))) {
        for(int j = y ; j ; j -= (j & (-j))) {
            res.first += nub[i][j].first;
            res.second += nub[i][j].second;
        }
    }
    return res;
}
int main() {
    int n , m , q;
    int t , r1 , c1 , r2 , c2;
    scanf("%d%d%d" , &n , &m , &q);
    srand((1 << 31));
    pair<ll , ll> ad , rd;
    while(q--) {
        scanf("%d%d%d%d%d" , &t , &r1 , &c1 , &r2 , &c2);
        if(t == 1) {
            ad.first = mmp[r1][c1].first = rand();
            ad.second = mmp[r1][c1].second = rand();
            rd.first = -ad.first;
            rd.second = -ad.second;
            add(r1 , c1 , ad);
            add(r2 + 1 , c1 , rd);
            add(r1 , c2 + 1 , rd);
            add(r2 + 1 , c2 + 1 , ad);
        }
        if(t == 2) {
            rd = mmp[r1][c1];
            ad.first = -rd.first;
            ad.second = -rd.second;
            add(r1 , c1 , ad);
            add(r2 + 1 , c1 , rd);
            add(r1 , c2 + 1 , rd);
            add(r2 + 1 , c2 + 1 , ad);
            mmp[r1][c1] = make_pair(0 , 0);
        }
        if(t == 3) {
            ad = query(r1 , c1);
            rd = query(r2 , c2);
            if(ad == rd) printf("Yes\n");
            else printf("No\n");
        }
    }
    return 0;
}

 

转载于:https://www.cnblogs.com/TnT2333333/p/7647962.html

树状数组(Fenwick Tree)是一种用于高效处理区间和查询的数据结构,常用于解一维数组的前缀和、区间更新和查询等问题。 在 Codeforces 上,树状数组常被用来解决一些与区间和查询有关的问题。它可以在 O(logn) 的时间内完成单点更新和查询,以及区间求和等操作。 下面是一个简单的示例代码,展示了如何实现一个基本的树状数组: ```cpp #include <iostream> #include <vector> using namespace std; // 获取最低位的 1 int getLowbit(int x) { return x & -x; } // 树状数组的单点更新操作 void update(vector<int>& fenwick, int index, int delta) { while (index < fenwick.size()) { fenwick[index] += delta; index += getLowbit(index); } } // 树状数组的前缀和查询操作 int query(vector<int>& fenwick, int index) { int sum = 0; while (index > 0) { sum += fenwick[index]; index -= getLowbit(index); } return sum; } int main() { int n; cin >> n; vector<int> fenwick(n + 1, 0); // 初始化树状数组 for (int i = 1; i <= n; i++) { int val; cin >> val; update(fenwick, i, val); } // 进行查询操作 int q; cin >> q; while (q--) { int type; cin >> type; if (type == 1) { int index, delta; cin >> index >> delta; update(fenwick, index, delta); } else if (type == 2) { int l, r; cin >> l >> r; int sum = query(fenwick, r) - query(fenwick, l - 1); cout << sum << endl; } } return 0; } ``` 在这个示例中,我们使用了一个长度为 n 的数组 `fenwick` 来表示树状数组。`update` 函数用于更新树状数组中的某个元素,`query` 函数用于查询树状数组中某个区间的和。 你可以根据具体问题的要求进行相应的修改和扩展。希望对你有所帮助!如果有任何疑问,请随时提问。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值